// VisCorBufList.h


#include <vector>


// UNDONE:  SequenceList code needs to check / set num bufs and copy if not
// enough bufs.  (Corona code may need to use volatile bufs if enough can't
// be allocated.)

// UNDONE:  CVisCorona::Release should free 

// UNDONE:  We need a global pointer to the CVisCoronaProvider object and 
// a way to get a buflist from the provider.  (Do we also want a list of
// CVisCorona objects that are in use?)


// UNDONE:  Other code changes:  Default provider / device key and dlg checkbox,
// flag to use default instead of dlg if default is available.



// Forward Declaration
class CVisCorona;



class CVisCoronaBufList
{
public:
	CVisCoronaBufList(void);

	~CVisCoronaBufList(void);


	int CBufCur(const CVisCorona *pCorona = 0);

	int CBufInUse(const CVisCorona *pCorona = 0);

	int CBufUnused(const CVisCorona *pCorona = 0);


	class CVisCoronaBuf *PBufGetPCorona(CVisCorona *pCorona);

	void ReleaseBuf(class CVisCoronaBuf *pBuf);

	static void VISAPI StaticReleaseBuf(void *pvData, void *pvBuf);

	void ReallocBufs(CVisCorona *pCorona, int cBuf);

	void RemoveBufs(const CVisCorona *pCorona);


private:
	CRITICAL_SECTION m_criticalsection;
	std::vector<class CVisCoronaBuf *> m_vectorpCoronaBuf;

	void RemoveBuf(class CVisCoronaBuf *pCoronaBuf);
};



class CVisCoronaBuf
{
public:
	//------------------------------------------------------------------
	// @group Constructor and destructor

	CVisCoronaBuf(void);

	~CVisCoronaBuf(void);


	//------------------------------------------------------------------
	// @group State flags

	bool FIsValid(void) const;

	bool FIsInUse(void) const;

	void SetFIsInUse(bool f);


	//------------------------------------------------------------------
	// @group Properties

	MIL_ID Milid(void) const;

	EVisImEncoding ImEncoding(void) const;

	int Dx(void) const;

	int Dy(void) const;

	SIZE Size(void) const;

	int CbData(void) const;

	void *PvData(void) const;

	class CVisCorona *PCorona(void) const;


	//------------------------------------------------------------------
	// @group Buffer allocation

	void Allocate(CVisCorona *pCorona);

	void Deallocate(void);


private:
	bool m_fInUse;
	MIL_ID m_milidBuf;
	EVisImEncoding m_evisimencoding;
	SIZE m_size;
	int m_cbData;
	void *m_pvData;
	class CVisCorona *m_pCorona;

#ifdef _DEBUG
	friend CVisCoronaBufList::~CVisCoronaBufList(void);
	static int s_cBufInUseCur;
	static int s_cBufInUseHigh;
	static void IncCBufInUse(void);
	static void DecCBufInUse(void);
#endif // _DEBUG
};


#include "VisCorBufList.inl"
