// VisCorBufList.inl


inline bool CVisCoronaBuf::FIsInUse(void) const
{
	assert(FIsValid());
	return m_fInUse;
}

inline void CVisCoronaBuf::SetFIsInUse(bool f)
{
	assert(FIsValid());
	m_fInUse = f;
}

inline MIL_ID CVisCoronaBuf::Milid(void) const
{
	assert(FIsValid());
	return m_milidBuf;
}

inline EVisImEncoding CVisCoronaBuf::ImEncoding(void) const
{
	assert(FIsValid());
	return m_evisimencoding;
}

inline int CVisCoronaBuf::Dx(void) const
{
	assert(FIsValid());
	return m_size.cx;
}

inline int CVisCoronaBuf::Dy(void) const
{
	assert(FIsValid());
	return m_size.cy;
}

inline SIZE CVisCoronaBuf::Size(void) const
{
	assert(FIsValid());
	return m_size;
}

inline int CVisCoronaBuf::CbData(void) const
{
	assert(FIsValid());
	return m_cbData;
}

inline void *CVisCoronaBuf::PvData(void) const
{
	assert(FIsValid());
	return m_pvData;
}

inline class CVisCorona *CVisCoronaBuf::PCorona(void) const
{
	assert(FIsValid());
	return m_pCorona;
}



inline CVisCoronaBufList::CVisCoronaBufList(void)
  : m_criticalsection(),
	m_vectorpCoronaBuf()
{
	InitializeCriticalSection(&m_criticalsection);
}

inline CVisCoronaBufList::~CVisCoronaBufList(void)
{
	DeleteCriticalSection(&m_criticalsection);

#ifdef _DEBUG
	if (!m_vectorpCoronaBuf.empty())
		OutputDebugString("\nWARNING:  Some Corona buffers were not freed!\n");

	char szBuf[256];
	sprintf(szBuf,
			"CVisCoronaBufList::~CVisCoronaBufList called,"
			" cBufInUseCur = %d, cBufInUseHigh = %d.\n",
			CVisCoronaBuf::s_cBufInUseCur,
			CVisCoronaBuf::s_cBufInUseHigh);
	OutputDebugString(szBuf);
#endif // _DEBUG
}
