// VisCorona.inl


inline void CVisCorona::CheckScales(void)
{
	if (m_fPreserveAspect)
	{
		// UNDONE:  We should include the offset in these equations.
		double dblScaleX = ((double) m_size.cx) / (m_sizeBaseline.cx);
		double dblScaleY = ((double) m_size.cy) / (m_sizeBaseline.cy);
		double dblScale = max(dblScaleX, dblScaleY);

		if (dblScale != m_dblScale)
			MdigControl(m_milidDig, M_GRAB_SCALE, dblScale);

		m_dblScale = dblScale;
	}
}


inline void CVisCorona::CheckFrameOrFieldGrab(bool fInit)
{
	// Grab fields if width and height are less than half baseline.
	// Note that is seems that the last condition should not be needed,
	// but it appears to be needed in practice.
	bool fGrabFields;
	if ((m_size.cx <= m_sizeBaseline.cx / 2)
			&& (((m_sizeBaseline.cy / 2 / m_size.cy) * 2 * m_size.cy)
					== m_sizeBaseline.cy)
			&& ((m_size.cy & 3) == 0))
	{
		fGrabFields = true;
	}
	else
	{
		fGrabFields = false;
	}

	if ((fInit) || (fGrabFields != m_fGrabFields))
	{
		if (fGrabFields)
		{
			MdigControl(m_milidDig, M_GRAB_FIELD_NUM, 1.0);
		}
		else
		{
			MdigControl(m_milidDig, M_GRAB_FRAME_NUM, 1.0);
		}

		m_fGrabFields = fGrabFields;
	}
}
